/// Icon Map
$icon-map-custom: (
  salary: (
    icon: '\e95c',
    font-space: 1,
  ),
  other-income: (
    icon: '\e94a',
    font-space: 1,
  ),
  transportation: (
    icon: '\e90f',
    font-space: 1,
  ),
  other: (
    icon: '\e94a',
    font-space: 1,
  ),
  cash: (
    icon: '\e911',
    font-space: 1,
  ),
  leisure: (
    icon: '\e967',
    font-space: 1,
  ),
  education: (
    icon: '\e924',
    font-space: 1,
  ),
  kids: (
    icon: '\e939',
    font-space: 1,
  ),
  shopping-cart: (
    icon: '\e964',
    font-space: 1,
  ),
  finances: (
    icon: '\e92b',
    font-space: 1,
  ),
  savings: (
    icon: '\e95d',
    font-space: 1,
  ),
  health: (
    icon: '\e92f',
    font-space: 1,
  ),
  beauty: (
    icon: '\e92f',
    font-space: 1,
  ),
  restaurant: (
    icon: '\e908',
    font-space: 1,
  ),
  utilities: (
    icon: '\e906',
    font-space: 1,
  ),
  groceries: (
    icon: '\e92d',
    font-space: 1,
  ),
  transfers: (
    icon: '\e96e',
    font-space: 1,
  ),
  bills: (
    icon: '\e909',
    font-space: 1,
  ),
);

/// Configures the custom-category icon color
/// @access public
$icon-custom-category-color: red !default;

// NLB Categories customization
// Retail Banking categories for dount chart
$nlb-category-list: (
  ('savings-investments', 'savings', #9f7859),
  ('shopping', 'shopping-cart', #e75185),
  ('salary', 'salary', #14a35f),
  ('income', 'other-income', #14a35f),
  ('salary-wages', 'salary', #14a35f),
  ('bars-restaurants', 'restaurant', #ca2e55),
  ('transfers', 'transfers', #ff9e9d),
  ('car-transport', 'transportation', #ffc531),
  ('transport', 'transportation', #ffc531),
  ('utilities', 'utilities', #5371ed),
  ('groceries', 'groceries', #ff970a),
  ('health-personal-care', 'health', #00b997),
  ('kids', 'kids', #987ed9),
  ('finances-insurance', 'finances', #9f7859),
  ('other', 'other', #8294b9),
  ('other-income', 'other', #8294b9),
  ('uncategorised', 'other', #8294b9),
  ('education', 'education', #003770),
  ('sport-leisure', 'leisure', #00aac4),
  ('cash', 'cash', #49ccff)
);

$chart-categories-colors: ();

// Populate $chart-categories-colors map
@each $category, $icon, $category-color, $chart-color in $nlb-category-list {
  $icon-content: null;
  $chart-category-color: if($chart-color, $chart-color, $category-color);

  @if $icon {
    $icon-content: map_get(map-get($icon-map-custom, str-slice($icon, 0)), 'icon');
  }

  $chart-categories-colors: append($chart-categories-colors, #{$category $chart-category-color $icon-content}, 'comma');
}

// For Chart Coloring
:root {
  @each $category, $icon, $color in $nlb-category-list {
    $chart-css-variable-name: '--chart-color-' + $category;
    #{$chart-css-variable-name}: #{$color};
  }
  --chart-categories-colors: #{$chart-categories-colors};
}

// if icon map prop exists, retrieve prop value,
// map-merge categories' prop:value to $icon-map, if icon prop exists
@each $category, $icon, $color in $nlb-category-list {
  @if $icon {
    $icon-map-custom: map-merge(
      $icon-map-custom,
      (
        'category-#{$category}': (
          'color': $color,
          'icon': $icon,
        ),
      )
    );
  }
}
